'*******************************************************************************
'* Mini-Wrteruhr (Spezial)                                                    *
'* auf Basis von Franzis "Ping Pong Retro Spielkonsole zum Selberbauen"        *
'* (c)2013 by DiLi-Soft - www.liebl-net.de/hard/mini-qlock2/mini-qlock2.php    *
'*                                                                             *
'* Nachempfunden der "QLOCKTWO" von Biegert: www.qlocktwo.com                  *
'*                                                                             *
'* Dieses Programm ist urheberrechtlich geschtzt und darf ausschlielich      *
'* fr nichtkommerzielle Zwecke verwendet werden.                              *
'*                                                                             *
'* Gewerbliche Nutzung ist ausgeschlossen!!                                    *
'*                                                                             *
'* Weitergabe des Quelltextes ist erwnscht - aber nur komplett, unverndert   *
'* und mit diesen Copyright-Anmerkungen !!!                                    *
'*                                                                             *
'* V1.0 vom 12.7.2013, erstellt unter BASCOM-AVR 2.0.7.5 (www.mcselec.com)     *
'*                                                                             *
'* (Spezialversion: durch Auslagern von Daten ins EEPROM ist der Code so kurz  *
'* geworden, dass mit der BASCOM-Demo-Version compiliert werden kann !!!)      *
'*                                                                             *
'*******************************************************************************


'Fusebits:                                         wichtig: ckopt=0 setzen !!!
$prog &HFF , &HE4 , &HC9 , &H00


'$sim : $dbg                                      'nur fr Tests im Simulator


$regfile = "m8adef.dat"                           'ATmega8
$crystal = 8000000                                'interner RC-Oszillator

$hwstack = 64                                     'berreichlich gro
$swstack = 64
$framesize = 64

$baud = 9600                                      'ggf. fr Tests


$include Eeps.bas                                 'enthlt EEPROM-Daten

Dim Min_pat(66) As Eram Byte                      'genau in dieser Reihenfolge
Dim Std_pat(26) As Eram Byte                      'liegen die Bytes im EEPROM
Dim Font(70) As Eram Byte                         'siehe "eeps.bas" !!!!


Dim Canvas(20) As Byte                            '"Bildschirmspeicher"
'(
Canvas(01) = &B00001111 : Canvas(02) = &B11111111 '12 bit / Zeile
Canvas(03) = &B00001010 : Canvas(04) = &B00000101 'der "Rahmen" zeigt die
Canvas(05) = &B00001001 : Canvas(06) = &B00001001 'verwendeten Bits
Canvas(07) = &B00001000 : Canvas(08) = &B10010001
Canvas(09) = &B00001000 : Canvas(10) = &B01100001
Canvas(11) = &B00001000 : Canvas(12) = &B01100001
Canvas(13) = &B00001000 : Canvas(14) = &B10010001
Canvas(15) = &B00001001 : Canvas(16) = &B00001001
Canvas(17) = &B00001010 : Canvas(18) = &B00000101
Canvas(19) = &B00001111 : Canvas(20) = &B11111111
')


Ddrc.0 = 1 : Zeile1 Alias Portc.0                 '10 Zeilen ( 12 Spalten)
Ddrc.1 = 1 : Zeile2 Alias Portc.1
Ddrc.2 = 1 : Zeile3 Alias Portc.2
Ddrc.3 = 1 : Zeile4 Alias Portc.3
Ddrd.4 = 1 : Zeile5 Alias Portd.4
Ddrd.5 = 1 : Zeile6 Alias Portd.5
Ddrd.6 = 1 : Zeile7 Alias Portd.6
Ddrd.7 = 1 : Zeile8 Alias Portd.7
Ddrb.0 = 1 : Zeile9 Alias Portb.0
Ddrb.1 = 1 : Zeile10 Alias Portb.1


Ddrb.2 = 1 : 4094_strobe Alias Portb.2            'Ansteuerpins fr Schiebe-
Ddrb.3 = 1 : 4094_clock Alias Portb.3             'register (SR)
Ddrb.4 = 1 : 4094_data Alias Portb.4


Dim Ticks As Integer                              'fr allgemeine Zeitzhlung
Dim Taster_ticks As Integer                       'wie lang war Taster gedrckt?

Dim Seks As Byte
Dim Mins As Byte : Dim Mins_alt As Byte
Dim Stds As Byte : Stds = 12                      'Startwert 12:00:00

Dim Modus As Byte                                 'Stellmodus: kein, Std, Min
                                                  '             0     1    2

Declare Sub Clear_canvas
Declare Sub Digit_to_canvas(byval D As Byte)      'Zahlenausgabe im Stellmodus
Declare Sub Time_to_canvas                        'Wrteruhr ausgeben


Ddrc.6 = 0
Portc.6 = 1                                       'PC6 (RESET) mit Pullup


Ddrd.2 = 0
Portd.2 = 1                                       'PD2 (INT0 = Taster) mit Pullup
Taster Alias Pind.2

On Int0 Onint0                                    'INT0 bei FALLING + RISING
Mcucr.isc00 = 1
Mcucr.isc01 = 0
Gicr.int0 = 1


Assr.as2 = 1                                      'Asynchroner Timer2-Betrieb
Tccr2.cs20 = 1                                    'Takt 32768Hz, no prescale

On Oc2 T2comp                                     '512 * / Sek
Ocr2 = 63                                         'Compare-Wert
Tccr2.wgm21 = 1                                   'CTC-Mode  (Clear Timer on Compare)
Timsk.ocie2 = 1                                   'Timer2-Compare-Interrupt an


Sreg.7 = 1                                        'alle Interrupt freigeben


'--------------------------- main () -------------------------------------------


Clear_canvas

Mins_alt = 255
Do                                                'Hauptschleife

   If Mins_alt <> Mins Then                       'neue Minute? dann ausgeben
      If Modus = 0 Then                           'nur wenn nicht Stellmodus
         Time_to_canvas
         Mins_alt = Mins
      End If
   End If

   If Taster_ticks > 0 Then                       'Taster gedrckt (und wieder
                                                  'losgelassen!)
      If Taster_ticks > 511 Then                  'Taster 1 Sek oder lnger gehalten
         Clear_canvas

         Incr Modus
         If Modus = 1 Then Call Digit_to_canvas(stds)
         If Modus = 2 Then Call Digit_to_canvas(mins)

         If Modus > 2 Then                        'fertig
            Modus = 0
            Seks = 0                              'immer mit NULL starten
            Mins_alt = 255                        'sofort ausgeben
         End If

      Else                                        'Taster kurz (< 1 sek) gedrckt
         If Taster_ticks > 20 Then                'Preller ignorieren

            If Modus = 1 Then                     'erst Stunden...
               Incr Stds
               If Stds > 12 Then Stds = 1
               Call Digit_to_canvas(stds)
            End If

            If Modus = 2 Then                     '...dann Minuten stellen
               Incr Mins
               If Mins > 59 Then Mins = 0
               Call Digit_to_canvas(mins)
            End If

         End If
      End If
      Taster_ticks = 0                            'Taste "abgeholt"

   End If                                         'Ende Stellmodus


Loop


End


'----------------------------------- SUBs --------------------------------------


Sub Clear_canvas                                  ' "CLS"
Local Lauf As Byte

   For Lauf = 1 To 20
   Canvas(lauf) = 0
   Next
End Sub



Sub Digit_to_canvas(byval D As Byte)              '2-stellige Zahl ausgeben
Local Font_idx_left As Byte : Local Font_idx_right As Byte
Local Canvas_idx_left As Byte : Local Canvas_idx_right As Byte
Local Lauf_left As Byte : Local Lauf_right As Byte
Local Temp_left As Byte : Local Temp_right As Byte

   Font_idx_right = D Mod 10                      'Einer
   Font_idx_left = D \ 10                         'Zehner
'Ziffer -> Index: 0 - > 1 , 1 - > 8 , 2 - > 15 , 3 - > 22 , 4 - > 29 , ...9 - > 64
   Font_idx_right = Font_idx_right * 7
   Incr Font_idx_right
   Font_idx_left = Font_idx_left * 7
   Incr Font_idx_left

   Lauf_left = Font_idx_left                      'Start-Index der Ziffern
   Lauf_right = Font_idx_right
   For Canvas_idx_left = 5 To 17 Step 2           'ab 3. Zeile links:5 (7,9,11..)
      Temp_left = Font(lauf_left)
      Shift Temp_left , Right , 2                 'die ersten 2 Bit gehren nach rechts
      Canvas(canvas_idx_left) = Temp_left
      Temp_left = Font(lauf_left)
      Incr Lauf_left                              'nchste Zeile

      Canvas_idx_right = Canvas_idx_left
      Incr Canvas_idx_right                       'ab 3. Zeile rechts:6 (8,10,12...)
      Temp_right = Font(lauf_right)
      Shift Temp_left , Left , 6                  'berhang der linken Zeile (die 2 rechten Bits)
      Canvas(canvas_idx_right) = Temp_left Or Temp_right       'zeilenweise Font bertragen
      Incr Lauf_right
   Next
End Sub



Sub Time_to_canvas                                'Zeit als Buchstabenblcke ausgeben
Local Stds_canvas As Byte : Local Mins_canvas As Byte
Local Index As Byte
Local 3bits As Byte : Local 8bits As Byte
Local Zeile As Byte
Local Std_incr As Byte
Local Lauf As Byte

   Clear_canvas                                   'Wiederholspeicher lschen

   '-------------- "ES IST" ausgeben -------------
   Canvas(1) = &B00000110 : Canvas(2) = &B11100000

   '----------  Canvas mit Minuten fllen:  ------
   Stds_canvas = Stds

   If Mins > 4 Then
      Index = Mins \ 5                            'Index auf Min_pat()
      Decr Index
      Index = Index * 6                           'index=(((mins div 5)-1)*6)+1
      Incr Index                                  '5...9 ->1, 10...14 -> 7, ...

      3bits = Min_pat(index)                      'enthlt zunchst auch Zeile u. Std_incr
      Zeile = 3bits And &B01111000
      'Shift Zeile , Right , 3                    '=Zeile
      'Shift Zeile , Left                         '=Zeile *2
      Shift Zeile , Right , 2
      Decr Zeile                                  '=Zeilenindex = Zeile *2 -1

      Std_incr = 3bits And &B10000000
      If Std_incr > 0 Then
         Incr Stds_canvas                         'wg. Stunden-Inkrement
         If Stds_canvas > 12 Then                 'z.B. Halb "4" bei 3:30
            Stds_canvas = Stds_canvas - 12
         End If
      End If
      3bits = 3bits And &B00000111                'Rest ausblenden

      Incr Index
      8bits = Min_pat(index)                      '3bits + 8bits nun komplett

      Canvas(zeile) = Canvas(zeile) Or 3bits
      Incr Zeile
      Canvas(zeile) = Canvas(zeile) Or 8bits

      For Lauf = 1 To 2                           'evtl. 2. und 3. Wort
         Incr Index
         3bits = Min_pat(index)

         Zeile = 3bits And &B01111000
         If Zeile > 0 Then
            Shift Zeile , Right , 2
            Decr Zeile

            3bits = 3bits And &B00000111
            Incr Index
            8bits = Min_pat(index)

            Canvas(zeile) = Canvas(zeile) Or 3bits
            Incr Zeile
            Canvas(zeile) = Canvas(zeile) Or 8bits
         End If
      Next

   '----------------- "Uhr" ausgeben: ------------
   Else                                           'nur bei Minuten <5:
      Canvas(20) = Canvas(20) Or &B00000111

   End If                                         'Mins > 4


   '------------ Einzel-Minuten ausgeben: --------
   Mins_canvas = Mins Mod 5
   Select Case Mins_canvas
      Case 1 : Canvas(07).3 = 1                   'in Spalte 1
      Case 2 : Canvas(07).3 = 1
               Canvas(09).3 = 1
      Case 3 : Canvas(07).3 = 1
               Canvas(09).3 = 1
               Canvas(11).3 = 1
      Case 4 : Canvas(07).3 = 1
               Canvas(09).3 = 1
               Canvas(11).3 = 1
               Canvas(13).3 = 1
   End Select

   '----------  Canvas mit Stunden fllen:  ------
   If Stds_canvas < 2 Then                        '"EIN" bzw. "EINS"
      If Mins < 5 Then
         Index = 1                                '"EIN"    ...   UHR
      Else
         Index = 3                                '"EINS"
      End If
   Else                                           '"ZWEI" ... "ZWLF"
      Index = Stds_canvas                         'Index auf Std_pat()
      Shift Index , Left
      Incr Index                                  'index = Std *2 +1
   End If                                         'Std <2

   3bits = Std_pat(index)                         'Stunden-Muster holen
   Incr Index
   8bits = Std_pat(index)

   Zeile = 3bits And &B01111000                   '3bits enthlt auch "Zeile"
   'Shift Zeile , Right , 3
   'Shift Zeile , Left
   Shift Zeile , Right , 2
   Decr Zeile                                     'index = Zeile *2 -1

   3bits = 3bits And &B00000111                   'Rest ausblenden
   Canvas(zeile) = Canvas(zeile) Or 3bits         'Stunden ausgeben (links)
   Incr Zeile                                     'index = Zeile *2
   Canvas(zeile) = Canvas(zeile) Or 8bits         'rechts

End Sub


'------------------------------ Interrupts (ISR) -------------------------------


Dim T2count As Word
Dim T2zeile As Byte                               'Vars fr ISR absichtlich global !!
Dim T2spalte As Byte
Dim T2canvas_idx As Byte
Dim T2temp As Byte
Dim T2cur As Byte

'Dim Std12 As Byte                                 'zhlt Tageshlften (z. Korrektur)  *****

T2comp:                                           'T2 on compare alle 1,95 ms = 512 Hz

   '---------------- Uhrenfunktionen: ------------
   Incr Ticks                                     'universeller Zeitzhler
   If Ticks = -32768 Then Ticks = 0               '07ff -> 0800 -> 0

   Incr T2count                                   'Uhrentakt
   If T2count = 512 Then
      T2count = 0

      If Modus = 0 Then                           'im Stellmodus: nicht ins "Gehege" kommen
         Incr Seks                                'im Sekunden-Takt
         If Seks > 59 Then
            Seks = 0
            Incr Mins
         End If
         If Mins > 59 Then
            Mins = 0
            Incr Stds
         End If
         If Stds > 12 Then
            Stds = 1
'           Incr Std12                            '*****
         End If
'(
         If Std12 = 5 Then                        '*****
            If Mins = 0 Then
               If Seks = 0 Then
                  Seks = Seks + 2
                  Std12 = 0
               End If
            End If
         End If
')
      End If

   End If

   '----- eine (1) Canvas-Zeile beschreiben: -----
   Incr T2zeile                                   'nchste Zeile ausgeben:
   If T2zeile > 10 Then T2zeile = 1               'ca. 51 Hz "Bildschirm"-Frequenz

   T2canvas_idx = T2zeile
   Shift T2canvas_idx , Left                      'Index=zeile*2 (rechts)
   T2temp = Canvas(t2canvas_idx)
   T2temp = T2temp Xor 255                        '1->0 : low-aktiv !!

   4094_strobe = 0                                'letzten SR-Zustand einfrieren

   For T2spalte = 0 To 7
      4094_data = T2temp.t2spalte
      4094_clock = 0
      4094_clock = 1                              'steigende Flanke: SR bernimmt
   Next

   Decr T2canvas_idx
   T2temp = Canvas(t2canvas_idx)                  'Index=zeile*2 -1 (links)
   T2temp = T2temp Xor 255

   For T2spalte = 0 To 3
      4094_data = T2temp.t2spalte
      4094_clock = 0
      4094_clock = 1
   Next

   'jetzt enthlt das SR eine (1) komplette Zeile (genau: 12 Spalten) !!
   4094_strobe = 1                                'SR-Ausg. freigeben

   Select Case T2zeile
      Case 1 : Zeile10 = 0                        'vorhergehende Zeile aus
               Zeile1 = 1                         'akt. Zeile ein
      Case 2 : Zeile1 = 0
               Zeile2 = 1
      Case 3 : Zeile2 = 0
               Zeile3 = 1
      Case 4 : Zeile3 = 0
               Zeile4 = 1
      Case 5 : Zeile4 = 0
               Zeile5 = 1
      Case 6 : Zeile5 = 0
               Zeile6 = 1
      Case 7 : Zeile6 = 0
               Zeile7 = 1
      Case 8 : Zeile7 = 0
               Zeile8 = 1
      Case 9 : Zeile8 = 0
               Zeile9 = 1
      Case 10 : Zeile9 = 0
                Zeile10 = 1
   End Select
Return                                            'Laufzeit der ISR ca. 0,15 ms



Dim Ticks_alt As Word

Onint0:                                           'Taster gedrckt oder losgelassen
   If Taster = 0 Then
      Ticks_alt = Ticks
   Else
      Taster_ticks = Ticks - Ticks_alt
      If Taster_ticks < 0 Then Taster_ticks = Taster_ticks + 32768
   End If
   Gifr.intf0 = 1                                 'evtl. Preller entfernen
Return